package de.hdm_stuttgart.mi.sd1.test.task1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.sd1.task1._5_ArrayZipper;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class Test_5_ArrayZipper extends ExaminationTestDefaults {


  @Test public void test_100_rv_null_empty() {
    Assert.assertArrayEquals(new int[]{}, _5_ArrayZipper.zipper(null, null));
    Assert.assertArrayEquals(new int[]{1, 2}, _5_ArrayZipper.zipper(null, new int[]{1, 2}));
    Assert.assertArrayEquals(new int[]{-1, -2}, _5_ArrayZipper.zipper(new int[]{-1, -2}, null));
    Assert.assertArrayEquals(new int[]{}, _5_ArrayZipper.zipper(new int[]{}, null));
    Assert.assertArrayEquals(new int[]{}, _5_ArrayZipper.zipper(null, new int[]{}));
    Assert.assertArrayEquals(new int[]{}, _5_ArrayZipper.zipper(new int[]{}, new int[]{}));
  }

  @Test public void test_140_rv_nullAndOne() {
    Assert.assertArrayEquals(new int[]{3, 7}, _5_ArrayZipper.zipper(new int[]{3}, new int[]{7}));
    Assert.assertArrayEquals(new int[]{7}, _5_ArrayZipper.zipper(null, new int[]{7}));
    Assert.assertArrayEquals(new int[]{7}, _5_ArrayZipper.zipper(new int[]{}, new int[]{7}));
    Assert.assertArrayEquals(new int[]{3}, _5_ArrayZipper.zipper(new int[]{3}, null));
    Assert.assertArrayEquals(new int[]{3}, _5_ArrayZipper.zipper(new int[]{3}, new int[]{}));
  }

  @Test public void test_160_rv_twoAndNull() {
    Assert.assertArrayEquals(new int[]{-1, 6}, _5_ArrayZipper.zipper(null, new int[]{-1, 6}));
    Assert.assertArrayEquals(new int[]{0, 0}, _5_ArrayZipper.zipper(null, new int[]{0, 0}));

    Assert.assertArrayEquals(new int[]{-1, 6}, _5_ArrayZipper.zipper(null, new int[]{-1, 6}));
    Assert.assertArrayEquals(new int[]{-1, 6}, _5_ArrayZipper.zipper(new int[]{}, new int[]{-1, 6}));
    Assert.assertArrayEquals(new int[]{-1, 6}, _5_ArrayZipper.zipper(new int[]{-1, 6}, null));
    Assert.assertArrayEquals(new int[]{-1, 6}, _5_ArrayZipper.zipper(new int[]{-1, 6}, new int[]{}));
  }

  @Test public void test_170_rv_five() {
    Assert.assertArrayEquals(new int[]{1, 2}, _5_ArrayZipper.zipper(new int[]{1}, new int[]{2}));
    Assert.assertArrayEquals(
        new int[]{0, 1, -1, 2, 9, 3, 4, 4, 6, 5},
        _5_ArrayZipper.zipper(new int[]{0, -1, 9, 4, 6}, new int[]{1, 2, 3, 4, 5}));
  }

  @Test public void test_180_rv_Exzess() {
    Assert.assertArrayEquals(
        new int[]{2, 1, 3},
        _5_ArrayZipper.zipper(new int[]{2, 3}, new int[]{1}));

    Assert.assertArrayEquals(
        new int[]{1, 2, 3},
        _5_ArrayZipper.zipper(new int[]{1}, new int[]{2, 3}));

    Assert.assertArrayEquals(
        new int[]{2, 1, 3, 4, 5, 6},
        _5_ArrayZipper.zipper(new int[]{2, 3, 4, 5, 6}, new int[]{1}));

    Assert.assertArrayEquals(
        new int[]{1, 2, 3, 4, 5, 6},
        _5_ArrayZipper.zipper(new int[]{1}, new int[]{2, 3, 4, 5, 6}));

    Assert.assertArrayEquals(
            new int[]{0, 1, -1, 2, 9, 3, 4, 4, 6, 5, 10, 20, 30},
            _5_ArrayZipper.zipper(new int[]{0, -1, 9, 4, 6, 10, 20, 30}, new int[]{1, 2, 3, 4, 5}));

    Assert.assertArrayEquals(
            new int[]{0, 1, -1, 2, 9, 3, 4, 4, 6, 5, -10, -20, -30},
            _5_ArrayZipper.zipper(new int[]{0, -1, 9, 4, 6}, new int[]{1, 2, 3, 4, 5, -10, -20, -30}));
  }
}
